<?xml version="1.0" encoding="UTF-8"?>
<!--

        This file is part of the Squashtest platform.
        Copyright (C) Henix, henix.fr

        See the NOTICE file distributed with this work for additional
        information regarding copyright ownership.

        This is free software: you can redistribute it and/or modify
        it under the terms of the GNU Lesser General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        this software is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public License
        along with this software.  If not, see <http://www.gnu.org/licenses/>.

-->
<databaseChangeLog xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
                   xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                   xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-2.0.xsd">

  <changeSet id="tm-1.17.0-SQUASH-5232-add-databasechangelog-new-columns" author="jprioux">
    <validCheckSum>8:aeea36396a9ec2a5a73082a8a593b123</validCheckSum>
    <comment>Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table</comment>
    <sql>
      ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS CONTEXTS VARCHAR(255) DEFAULT NULL;
      ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS LABELS VARCHAR(255) DEFAULT NULL;
      ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS DEPLOYMENT_ID VARCHAR(10) DEFAULT NULL;
    </sql>
  </changeSet>

  <changeSet id="tm-1.17.0" author="jthebault">
    <comment>Update TM database version number</comment>
    <update tableName="CORE_CONFIG">
      <column name="VALUE" value="1.17.0"/>
      <where>STR_KEY = 'squashtest.tm.database.version'</where>
    </update>
  </changeSet>

  <changeSet id="tm-1.17.0-feature-6921" author="zyang">
    <comment>Adds a status field to campaign and iteration</comment>
    <addColumn tableName="CAMPAIGN">
      <column name="CAMPAIGN_STATUS" type="VARCHAR(30)" defaultValue="UNDEFINED">
        <constraints nullable="false"/>
      </column>
    </addColumn>
    <addColumn tableName="ITERATION">
      <column name="ITERATION_STATUS" type="VARCHAR(30)" defaultValue="UNDEFINED">
        <constraints nullable="false"/>
      </column>
    </addColumn>
  </changeSet>

  <changeSet id="tm-1.17.0" author="zyang">
    <createTable tableName="REPORT_DEFINITION">

      <column name="REPORT_ID" type="BIGINT" autoIncrement="true" remarks="autogenerated ID">
        <constraints primaryKey="true" nullable="false"/>
      </column>

      <column name="NAME" type="java.sql.Types.VARCHAR(255)" remarks="The name of this chart"/>

      <column name="DESCRIPTION" type="CLOB" remarks="additional informations about this report"/>

      <column name="PLUGIN_NAMESPACE" type="java.sql.Types.VARCHAR(255)" remarks="The namespace of the report plugin"/>

      <column name="PARAMETERS" type="CLOB" remarks="parameters to generate the report"/>

      <column name="USER_ID" type="BIGINT" remarks="foreign key to the owner of this report definition">
        <constraints nullable="false" foreignKeyName="fk_report_owner"
                     references="CORE_USER(PARTY_ID)"/>
      </column>

      <column name="PROJECT_ID" type="BIGINT" remarks="foreign key to the projet">
        <constraints nullable="false" foreignKeyName="fk_project_report_definition_project_id"
                     references="PROJECT(PROJECT_ID)"/>
      </column>

      <column name="CREATED_BY" type="java.sql.Types.VARCHAR(50)">
        <constraints nullable="false"/>
      </column>

      <column name="CREATED_ON" type="DATETIME">
        <constraints nullable="false"/>
      </column>

      <column name="LAST_MODIFIED_BY" type="java.sql.Types.VARCHAR(50)" defaultValue="NULL"/>
      <column name="LAST_MODIFIED_ON" type="DATETIME" defaultValue="NULL"/>

    </createTable>
  </changeSet>

  <changeSet id="tm-1.17.0-feature-6921" author="cholc">
    <comment>Adds a execution status field to the test suites</comment>
    <addColumn tableName="TEST_SUITE">
      <column name="EXECUTION_STATUS" type="VARCHAR(255)" defaultValue="READY">
      </column>
    </addColumn>
  </changeSet>

  <changeSet id="tm-1.17.0-feature-sqtm-167" author="bsiri">

    <comment>
      Adding the ability to use application-level credentials that allows Squash interact with a bugtracker on its own
      (ie instead of requiring the current user to authenticate).
    </comment>

    <createTable tableName="STORED_CREDENTIALS">

      <column name="CREDENTIAL_ID" type="BIGINT" autoIncrement="true" remarks="primary key">
        <constraints primaryKey="true" nullable="false"/>
      </column>

      <column name="ENC_VERSION" type="java.sql.Types.SMALLINT" remarks="the version of encryption service used. Possibly the value will remain to 1 forever."/>

      <column name="ENC_CREDENTIALS" type="TEXT" remarks="the credentials as an encrypted string"/>

      <column name="AUTHENTICATED_SERVER" type="BIGINT" remarks="foreign key to the server to authenticate">
        <constraints foreignKeyName="fk_stored_credentials_authenticated_server" references="BUGTRACKER(BUGTRACKER_ID)" deleteCascade="true"/>
      </column>

    </createTable>


    <addColumn tableName="BUGTRACKER">
      <column name="AUTH_POLICY" type="VARCHAR(30)" remarks="the policy that decides who needs to authenticate" defaultValue="USER" />
    </addColumn>

  </changeSet>


  <changeSet id="tm-1.17.0-jira-sync-01" author="jthebault">
    <comment>Add a remote synchronisation table in squash tm.</comment>
    <createTable tableName="REMOTE_SYNCHRONISATION">

      <column name="REMOTE_SYNCHRONISATION_ID" type="BIGINT"
              autoIncrement="true">
        <constraints primaryKey="true" nullable="false"/>
      </column>

      <column name="PROJECT_ID" type="BIGINT">
        <constraints nullable="false"
                     foreignKeyName="fk_remote_sync__project__project_id"
                     references="PROJECT(PROJECT_ID)" />
      </column>

      <column name="SERVER_ID" type="BIGINT">
        <constraints nullable="false"
                     foreignKeyName="fk_remote_sync__bugtracker__bugtracker_id"
                     references="BUGTRACKER(BUGTRACKER_ID)" />
      </column>

      <column name="REMOTE_SYNCHRONISATION_NAME" type="VARCHAR(255)">
        <constraints nullable="false"/>
      </column>

      <column name="KIND" type="VARCHAR(50)">
        <constraints nullable="false"/>
      </column>

      <column name="REMOTE_SELECT_TYPE" type="VARCHAR(50)"/>

      <column name="REMOTE_SELECT_VALUE" type="VARCHAR(1000)"/>

      <column name="LAST_SUCCESSFUL_SYNC_DATE" type="DATETIME"/>

      <column name="LAST_SYNC_DATE" type="DATETIME"/>

      <column name="LAST_SYNC_STATUS" type="VARCHAR(20)"/>

      <column name="SYNC_STATUS" type="VARCHAR(20)"/>

      <column name="REMOTE_SYNCHRONISATION_OPTIONS" type="CLOB"/>

    </createTable>
  </changeSet>

  <changeSet id="tm-1.17.0-jira-sync-02" author="jthebault">
    <comment>Add a remote folder synchronisation table in squash tm.</comment>
    <createTable tableName="REQUIREMENT_FOLDER_SYNC_EXTENDER">

      <column name="RF_SYNC_EXTENDER_ID" type="BIGINT"
              autoIncrement="true">
        <constraints primaryKey="true" nullable="false"/>
      </column>

      <column name="REMOTE_SYNCHRONISATION_ID" type="BIGINT" remarks="Only one master folder should be targeted by a given synchronisation">
        <constraints nullable="false"
                     foreignKeyName="fk_req_folder_sync_extender__remote_sync_remote_sync_id"
                     references="REMOTE_SYNCHRONISATION(REMOTE_SYNCHRONISATION_ID)" />
      </column>

      <column name="REMOTE_FOLDER_ID" type="VARCHAR(255)">
      </column>

      <column name="REMOTE_FOLDER_STATUS" type="VARCHAR(50)">
      </column>

      <column name="REQUIREMENT_FOLDER_ID" type="BIGINT" remarks="Only one extender for any folder in Squash TM">
        <constraints nullable="false"
                     foreignKeyName="fk_req_folder_sync_extender__req_folder__rln_id"
                     references="REQUIREMENT_FOLDER(RLN_ID)" unique="true" />
      </column>

      <column name="TYPE" type="VARCHAR(30)">
        <constraints nullable="false"/>
      </column>

    </createTable>
  </changeSet>

  <changeSet id="tm-1.17.0-jira-sync-03" author="jthebault">
    <dropNotNullConstraint tableName="REQUIREMENT_SYNC_EXTENDER" columnName="REMOTE_FILTER_NAME" columnDataType="VARCHAR(150)"/>

    <addColumn tableName="REQUIREMENT_SYNC_EXTENDER">

      <column name="REMOTE_SYNCHRONISATION_ID" type="BIGINT">
        <constraints nullable="true"
                     foreignKeyName="fk_req_sync_extender__remote_sync_remote_sync_id"
                     references="REMOTE_SYNCHRONISATION(REMOTE_SYNCHRONISATION_ID)" />
      </column>

      <column name="REMOTE_LAST_UPDATED" type="DATETIME"/>

      <column name="REMOTE_PARENT_ID" type="VARCHAR(30)"/>

    </addColumn>

    <createIndex tableName="REQUIREMENT_SYNC_EXTENDER" indexName="req_sync_extender_remote_parent_id_idx">
      <column name="REMOTE_PARENT_ID" />
    </createIndex>

  </changeSet>

  <changeSet id="tm-1.17.0-Issue-6967" author="jthebault">
    <createIndex tableName="TEST_CASE_LIBRARY_NODE" indexName="tcln_name_idx">
      <column name="NAME" />
    </createIndex>
  </changeSet>

</databaseChangeLog>
